#!/bin/bash

check_local_timezone() {
  dt=`date "+%H:%M" | grep "00:00"`
  if [[ -n ${dt} ]]; then
    # do sync time
    cp /usr/share/zoneinfo/Asia/Shanghai /etc/localtime
    ntpdate cn.pool.ntp.org
    hwclock --systohc
  fi
}

check_tools_status() {
    # check ntpdate
    exist=`whereis ntpdate | awk '{print $2}'`
    system=`cat /etc/issue |grep Ubuntu |wc -l`
    
    if [[ -z ${exist} ]]; then
       if [[ -z ${system} ]]; then
          yum install ntpdate -y
       else
          apt-get install ntpdate -y
       fi
    fi

    # check smartctl
    #exist2=`whereis smartctl | awk '{print $2}'`

    #if [[ -z ${exist2} ]]; then
    #   if [[ -z ${system} ]]; then
    #      yum install smartmontools -y
    #   else
    #      apt-get install smartmontools -y
    #   fi
    #fi
}

start_app() {
  /etc/pear/pear_scripts/replace.sh
  check_local_timezone
  /root/pear/tools/post.sh
  mv /etc/pear/pear_docker /etc/pear/pear_plugin
  /usr/sbin/pear_restart --install_path=/ &
  nohup /root/pear/tools/pear_one_minute_check.sh >/dev/null 2>&1 &
  nohup /root/pear/tools/pear_ten_minutes_check.sh >/dev/null 2>&1 &
  nohup /root/pear/tools/pear_debug.sh >/dev/null 2>&1 &
  sed -i 's/sleep 5/sleep 20/g' /etc/rc.local
  ulimit -HSn 131072
  ulimit -c unlimited
  check_tools_status
}

stop_app() {
  killall -9 pear_restart
  sleep 2
  killall -9 pear_update
  killall -9 pear_monitor
  killall -9 pear_httpd
  killall -9 pear_s
  killall -9 socks_server
  killall -9 scan.sh
  killall -9 ksp2p-server
  killall -9 pear_findppp
  killall -9 ks-agent
  killall -9 pear_one_minute_check.sh
  killall -9 pear_ten_minutes_check.sh
  killall -9 ptty
}

case "$1" in
  start)
    stop_app
    start_app
    ;;
  stop)
    stop_app
    ;;
  reload|restart|force-reload)
    stop_app
    start_app
    ;;
  *)
    echo "$0 start|stop|reload|restart"
    exit 1
esac

exit 0
