#!/bin/bash

echo "pear_on_minute_check"

function check_lo()
{
     # ip address add 127.0.0.1/8  scope host  dev  lo 
     # ifconfig lo 127.0.0.1 netmask 255.0.0.0 up
     # https://stackoverflow.com/questions/8529181/which-terminal-command-to-get-just-ip-address-and-nothing-else
     
     # ifconfig lo 2>/dev/null|awk '/inet addr:/ {print $2}'|sed 's/addr://'
     local_ip=`ifconfig lo | grep 'inet addr' | cut -d: -f2 | awk '{print $1}'`
     if [ "i$local_ip" == "i" ]
     then 
          echo "ip is null"
          local_ip=`ip addr show lo | grep "host lo" | grep -Po 'inet \K[\d.]+'`
     fi 

     if [ "i$local_ip" == "i" ]
     then 
          echo "ip is null"
          local_ip=`ifconfig lo | awk '/t addr:/{gsub(/.*:/,"",$2);print$2}'`
     fi 
     if [ "i$local_ip" == "i" ]
     then 
          echo "ip is null"
          local_ip=`ip -f inet addr show lo | grep -Po 'inet \K[\d.]+'`
     fi
     
     if [ "i$local_ip" != "i127.0.0.1" ]
     then
          # record lo address abnormal
          echo `date +%s` "lo address abnormal"  >> /root/pear/log/checkoneminute.txt
          ifconfig lo 127.0.0.1 netmask 255.0.0.0 up
     fi 
}

function check_dns()
{
     DNS1_NAME=download.openfogos.com
     DNS2_NAME=updatetencent.webrtc.win
     DNS3_NAME=docker.webrtc.win

     NUM1=`cat /etc/hosts | grep ${DNS1_NAME} |wc -l`

     if [ "${NUM1}" -lt "1" ];then
        echo 49.234.47.74 ${DNS1_NAME} >> /etc/hosts
     fi

     NUM2=`cat /etc/hosts | grep ${DNS2_NAME} |wc -l`
     
     if [ "${NUM2}" -lt "1" ];then
        echo 49.234.47.74 ${DNS2_NAME} >> /etc/hosts
     fi

     NUM3=`cat /etc/hosts | grep ${DNS3_NAME} |wc -l`
     
     if [ "${NUM3}" -lt "1" ];then
        echo 49.234.47.74 ${DNS3_NAME} >> /etc/hosts
     fi

     NUM4=`cat /etc/resolv.conf | grep 119.29.29.29 |wc -l`
     
     if [ "${NUM4}" -lt "1" ];then
        echo nameserver 119.29.29.29 >> /etc/resolv.conf
     fi

     NUM5=`cat /etc/resolv.conf | grep 114.114.114.114 |wc -l`
     
     if [ "${NUM5}" -lt "1" ];then
        echo nameserver 114.114.114.114 >> /etc/resolv.conf
     fi
}

function pear_on_minute_check()
{
     check_lo
     check_dns
}

while true :
do
     pear_on_minute_check 
     sleep 60
done 
